// Info Viewer V1.0 Copyright (C) 1997 Wen-Shin Wang

#define Uses_TRect
#define Uses_TView
#define Uses_TDrawBuffer
#include <tv.h>

#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <strstrea.h>
#include <iomanip.h>
#include <time.h>
#include <stdio.h>
#include <dpmi.h>

#include "gadgets.h"

//
// -------------- GO32 Memory Viewer functions
//

void THeapView::update() {
	unsigned long _p_mem,_v_mem;
	get_mem_info(_v_mem,_p_mem);
	if (_p_mem != p_mem || _v_mem != v_mem) {
		v_mem = _v_mem;
		p_mem = _p_mem;
		drawView();
	}
}

static char scale_mem(float & b) {
	if (b <= 1024) return 'B';
	b /= 1024;
	if (b <= 1024) return 'K';
	b /= 1024;
	if (b <= 1024) return 'M';
	b /= 1024;
	return 'G';
}

void THeapView::draw(){
	TDrawBuffer b;
	char dummy[80];
	char v=' ',p=' ';
	float _v_mem,_p_mem;
	_v_mem=(float)v_mem;
	_p_mem=(float)p_mem;
	v = scale_mem(_v_mem);
	p = scale_mem(_p_mem);
	uchar c = getColor(2);
	b.moveChar(0, ' ', c, size.x);
	sprintf(dummy,"%4.2f%c/%4.2f%c",_v_mem,v,_p_mem,p);
	b.moveStr(0,dummy,c);
	writeLine(0,0,size.x,1,b);
}

void get_mem_info(unsigned long & virt_mem,unsigned long & phys_mem) {
	_go32_dpmi_meminfo info;
	_go32_dpmi_get_free_memory_information(&info);
	virt_mem = info.available_memory;
	phys_mem = info.available_physical_pages * 4096;
}

//
// -------------- Clock Viewer functions
//

TClockView::TClockView( TRect& r ) : TView( r ) {
	strcpy(lastTime, "        ");
	strcpy(curTime, "        ");
}


void TClockView::draw() {
TDrawBuffer buf;
char c = getColor(2);

	buf.moveChar(0, ' ', c, size.x);
	buf.moveStr(0, curTime, c);
	writeLine(0, 0, size.x, 1, buf);
}


void TClockView::update() {
time_t t = time(0);
char *date = ctime(&t);

	date[19] = '\0';
	strcpy(curTime, &date[11]);		   /* Extract time. */
	if( strcmp(lastTime, curTime) ) {
		drawView();
		strcpy(lastTime, curTime);
	}
}

