// Info Viewer V1.0 Copyright (C) 1997 Wen-Shin Wang

/* This file is part of RHIDE, Copyright (C) 1996 Robert Hhne */
/***************************************************************

   (c) 1996 by Salvador Eduardo Tropea (SET).
   e-mail: salvador@inti.edu.ar

   You can use this code for any purpose if you don't remove the
original copyright.

   Filename -		 Inf.cpp

   Functions:
					Member functions of following classes
						TInfViewer
						TInfWindow
						THelpControlDialog
						TStrListBox

***************************************************************/
#define Uses_TStreamableClass
#define Uses_TPoint
#define Uses_TStreamable
#define Uses_TRect
#define Uses_TScrollBar
#define Uses_TScroller
#define Uses_TDrawBuffer
#define Uses_TEvent
#define Uses_TWindow
#define Uses_TKeys
#define Uses_TPalette
#define Uses_TButton
#define Uses_TListBox
#define Uses_TLabel
#define Uses_TDialog
#define Uses_MsgBox
#define Uses_TFindDialogRec
#define Uses_TInputLine
#define Uses_TCheckBoxes
#define Uses_TRadioButtons
#define Uses_THistory
#define Uses_TSItem
#define Uses_TIndicator
#define Uses_TStatusLine
#include <tv.h>

#include "Inf.h"
#include <string.h>
#include <limits.h>
#include <sys\stat.h>
#include <ctype.h>
#include <io.h>

extern execDialog( TDialog *d, void *data );
const char * const near TCollectionNoSort::name="TCollectionNoSort";
extern int gteGraphicText;
#define GT gteGraphicText



/***************************************************************
 class TInfViewer
***************************************************************/

static int PointInCrossRef(TPoint point,TInfTopic *topic,int & i) {

	if (!topic) return -1;
	int crossCount = topic->numRefs;
	i = 0;
	if (crossCount == 0) return -1;
	point.y++;
	for (i=0;i<crossCount;i++) {
		CrossRef & ref = topic->crossRefs[i];
		if (ref.line > point.y) return -1;
		// Support for crossRefs that cross lines, slow
		if (ref.line == (point.y-1)) {
			if (ref.linebreak && point.x<=ref.linebreak) return i;
			continue;
		}
		if (ref.line < point.y) continue;
		if (ref.offset > point.x) return -1;
		if (ref.offset+ref.length <= point.x) continue;
		return i;
	}
	i = crossCount;
	return -1;
}


TInfViewer::TInfViewer( const TRect& bounds, TScrollBar* aHScrollBar,
	TScrollBar* aVScrollBar, TInfFile *aInfFile, char *context, char *match )
	: TScroller( bounds, aHScrollBar, aVScrollBar ) {

char NameCopy[MAX_NODE_NAME];
// pumm!!! bug killed, fucking strings in code by GCC, i need a buffer not
// a simple string (my fault).
	strcpy(NameCopy,context);

	options |= ofSelectable;
	growMode = gfGrowHiX | gfGrowHiY;
	hFile = aInfFile;
	topic = aInfFile->getTopic(NameCopy);
	topic->setWidth(size.x);
	setLimit(topic->maxWidth(), topic->numLines());
	QuickLen=0;

int LaPego;
	if ((selected=topic->selBestMatch(match,LaPego))!=0) {
	int y=topic->crossRefs[selected-1].line-1;
		cursor.x=topic->crossRefs[selected-1].offset;
		if (y>(size.y>>1)) {
			delta.y=y-(size.y>>1);
			cursor.y=size.y>>1;
		}
		else {
			delta.y=y;
			cursor.y=1;
		}
		delta.x=0;
		scrollTo(cursor.x,y);
	}

	TextSelected = False;
	findStr[0]=0;
	findType=0;
	findWhere=fitInTopic;
	lastSearch=0;
	OpenVerbose=1;

// History
	HistPoint=0;
	History= new TCollectionNoSort(10,10);
	stHisto *h = new stHisto;
	strcpy(h->Name,"(");
	strcat(h->Name,hFile->NameOfFile);
	strcat(h->Name,")");
	strcat(h->Name,context);
	h->HisPos=delta;
	h->HisSel=selected;
	History->insert((void *)h);

	if (LaPego) {
		switchToTopic(topic->crossRefs[selected-1].Name);
		cursor.x=delta.x=cursor.y=delta.y=0;
	}
	SetTitle( hFile->NameOfFile, topic->Node );
}

TInfViewer::~TInfViewer() {
	delete hFile;
	delete topic;
	delete History;
}

void TInfViewer::changeBounds( const TRect& bounds ) {
	TScroller::changeBounds(bounds);
	topic->setWidth(size.x);
	setLimit(topic->maxWidth() , topic->numLines());
}

static void moveChar(int indent, char c, char attr, int count, ushort *b) {
ushort val=c | (attr<<8);
	for (b+=indent; count; count--, b++) *b=val;
}

static void moveStr(int indent, char *buffer, char attr, ushort *b) {
char *s=(char *)(b+indent);
	while (*buffer) {
		*s=*buffer;
		*(s+1)=attr;
		s+=2;
		buffer++;
	}
}


void TInfViewer::draw()
{
ushort b[256];
char linea[256],*line;
char buffer[256];
char *bufPtr;
unsigned char aux;
int i, j, l, k;
int keyCount;
ushort normal, keyword, selKeyword, c,selWord,QuickWord;
TPoint keyPoint;
uchar keyLength;
char *keyRef;
int NumCrossRefs=topic->getNumCrossRefs();
int LineaReal;
int Exceso;
char *bf=(char *)b;

	normal = getColor(1);
	keyword = getColor(2);
	selKeyword = getColor(3);
	QuickWord = (selKeyword &0xf0)|0xc;
	selWord = getColor(4)&0xf0;
	keyCount = 0;
	keyPoint.x = 0;
	keyPoint.y = 0;
	topic->setWidth(size.x);

 // Saltear las crossrefs que estn antes en la pantalla

	if (NumCrossRefs > 0) {
		do {
			topic->getCrossRef(keyCount++, keyPoint, keyLength, keyRef, Exceso);
		} while ( (keyCount <= NumCrossRefs) && (keyPoint.y <= delta.y));
	}

	for (i = 1, LineaReal=delta.y+1; i <= size.y; ++i,LineaReal++) {
		topic->getLine(LineaReal,linea);
		if (linea[0]==30) {
			aux=(unsigned char)linea[1];
			if (aux<='9') c=(aux-'0')<<4;
			else c=(aux-(unsigned char)'A'+10)<<4;
			aux=(unsigned char)linea[2];
			if (aux<='9') c+=aux-'0';
			else c+=aux-(unsigned char)'A'+10;
			line=linea+3;
		}
		else {
			c=normal;
			line=linea;
	   }
		moveChar(0, ' ', c, size.x, b); // Attr pedido

		if ((int)strlen(line) > delta.x) {
			bufPtr = line + delta.x;
			strncpy(buffer, bufPtr, size.x);
			buffer[size.x] = 0;
			moveStr(0, buffer, c, b);
		}
		else moveStr(0, "", c, b);


		while (LineaReal == keyPoint.y) {
			if (Exceso>0) l = keyLength-Exceso;
			else l = keyLength;
			if (keyPoint.x < delta.x ) {
				l -= (delta.x - keyPoint.x);
				keyPoint.x = delta.x;
			}

			if (keyCount == selected) {
			int shift=keyPoint.x-delta.x,QuickStart=0;
			char *cp=&bf[shift*2];
				while ( !isalpha(cp[QuickStart*2]) ) QuickStart++;
				if (QuickStart) for (j = 0; j < QuickStart; ++j) bf[(shift + j)*2+1]=selKeyword;
				if (QuickLen) for (j = QuickStart; j < QuickLen+QuickStart; ++j) bf[(shift + j)*2+1]=QuickWord;
				for (j = QuickLen+QuickStart; j < l; ++j) bf[(shift + j)*2+1]=selKeyword;
			}
			else {
				for (j = 0; j < l; ++j) bf[(keyPoint.x - delta.x + j)*2+1]=keyword;
			}
			if (Exceso>0) {
				keyPoint.x=0;
				keyPoint.y++;
				keyLength=Exceso+1;
				Exceso=0;
			}
			else {
				++keyCount;
				if (keyCount <= NumCrossRefs) topic->getCrossRef(keyCount-1, keyPoint, keyLength, keyRef, Exceso);
				else keyPoint.y = 0;
			}
		}

	 // Paint the selection
		if (TextSelected && LineaReal>=LineStartSelect && LineaReal<=LineEndSelect) {
		int start;
			if (LineStartSelect==LineEndSelect) {
				l=ColEndSelect-ColStartSelect;
				if ( ColStartSelect<delta.x ) {
					l -= (delta.x - ColEndSelect);
					start = 0;
				}
				else start = ColStartSelect - delta.x;
			}
			else {
				if (LineaReal==LineStartSelect) {
					start=ColStartSelect-delta.x;
					l=size.x-start;
				}
				else if (LineaReal==LineEndSelect) {
					start=0;
					l=ColEndSelect-delta.x;
				}
				else {
					start=0;
					l=size.x;
				}
			}
			for(j = 0, k=start*2+1; j < l; ++j, k+=2) bf[k]=(bf[k] & 0x0F) | selWord;
		}
		writeLine(0, i-1, size.x, 1, b);
	}
}

void TInfViewer::SetTitle(char *File, char *Node)
{
 if (owner) /* is a window ? */
   {
	char *newTitle = new char[25+strlen(File)+strlen(Node)+2];

	if (newTitle)
	  {
	   sprintf(newTitle,"InfView - File: %s - Node: %s",File,Node);

	   delete (char *)((TWindow *)owner)->title;
	   (char *)((TWindow *)owner)->title = newTitle;
	   ((TView*)((TWindow *)owner)->frame)->drawView();
	  }
   }
}

TPalette& TInfViewer::getPalette() const {
	static TPalette palette(cInfViewer, sizeof( cInfViewer)-1);
	return palette;
}

void TInfViewer::makeSelectVisible() {
int ProxLine;
TPoint keyPoint;
uchar keyLength;
char *keyRef;

	topic->getCrossRef(selected-1, keyPoint, keyLength, keyRef, ProxLine);
	makeVisible(keyPoint,keyLength);
}


void TInfViewer::makeVisible( TPoint& keyPoint, int length ) {
int x,y,s=0;

	if ((keyPoint.y<=delta.y) || (keyPoint.y>delta.y+size.y)) s=y=keyPoint.y-(size.y /2);
	else y=delta.y;
	if (((keyPoint.x+length)<=delta.x) || keyPoint.x>=delta.x+size.x) s=x=keyPoint.x;
	else x=0;
	if (s) scrollTo(x,y);
	else drawView();
}

void TInfViewer::TabToNext(int Direction) {
int ProxLine,visible;
TPoint keyPoint;
uchar keyLength;
char *keyRef;

	if (selected) {
		topic->getCrossRef(selected-1, keyPoint, keyLength, keyRef, ProxLine);
		if ((keyPoint.y<=delta.y) || (keyPoint.y>delta.y+size.y) || ((keyPoint.x+keyLength)<=delta.x) || (keyPoint.x>=delta.x+size.x)) visible=0; else visible=1;
	} else visible=0;
	if (!Direction) { //go on next
		if (!visible)  //not visible
			if (PointInCrossRef(delta,topic,selected) >= 0) selected++;
		selected++;
		if (selected > topic->getNumCrossRefs()) selected = 1;
	}
	else { //go on previous
		if (!visible)  //not visible
			PointInCrossRef(delta+size-(TPoint){1,1},topic,selected);
		else
			selected--;
		if (selected == 0) selected = topic->getNumCrossRefs();
	}
	if ( topic->getNumCrossRefs() != 0 ) makeSelectVisible();
}


void TInfViewer::switchToTopic( char *keyRef, TPoint Pos ) {
char NameCopy[MAX_NODE_NAME];

 // Because i can destroy the original bellow, keyRef is from topic and i go
 // to detroy it.
	strcpy(NameCopy,keyRef);

	if (topic != 0) delete topic;
//	  topic = hFile->getTopic(NameCopy,OpenVerbose);
	topic = hFile->getTopic(NameCopy);
	SetTitle( hFile->NameOfFile, topic->Node );

	topic->setWidth(size.x);
	setLimit(topic->maxWidth(), topic->numLines());
	scrollTo(Pos.x,Pos.y);
	// No search
	TextSelected=False;
	lastSearch=topic->Text;
	drawView();
}

void TInfViewer::switchToTopic( char *keyRef ) {
TPoint Pos={0,0};

	AddToHistory(keyRef);
	selected = 0;
	switchToTopic( keyRef,Pos );
}

void TInfViewer::switchToTopic( stHisto *h ) {
	AddToHistory(h->Name);
	selected=h->HisSel;
	switchToTopic(h->Name,h->HisPos);
}

static void AddFileToNode(char *dest, char *source, char *file) {
	if (source[0]=='(') strcpy(dest,source);
	else {
		dest[0]='(';dest[1]=0;
		strcat(dest,file);
		strcat(dest,")");
		strcat(dest,source);
	}
}

void TInfViewer::AddToHistory(char *context) {
stHisto *h = (stHisto *)History->at(HistPoint);

	h->HisPos = delta;
	h->HisSel=selected;

	h = new stHisto;

	AddFileToNode(h->Name,context,hFile->NameOfFile);
	History->insert(h);
	HistPoint++;

	if (HistPoint>=MAX_HIST_DEEP) {
		History->atRemove(0);
		HistPoint--;
	}
}

char *TInfViewer::TakeFromHistory(TPoint& Pos) {
stHisto *h;
	if (HistPoint>0) {
		History->atRemove(HistPoint--);
		h=(stHisto *)History->at(HistPoint);
	}
	else h=(stHisto *)History->at(0);

	selected=h->HisSel;
	Pos = h->HisPos;
	return h->Name;
}


void TInfViewer::ControlWindow()
{
	int Comando = execDialog( new THelpControlDialog(History), NULL );
	if (Comando>=chcdHistSel) {
			switchToTopic((stHisto *)History->at(Comando-chcdHistSel));
	}
}

void TInfViewer::GotoWindow()
{
TFindInfDialogRec findRec( findStr, findType, findWhere );
	if ( execDialog( createGoToDialog(), &findRec ) != cmCancel ) switchToTopic(findRec.find);
}

void TInfViewer::handleEvent( TEvent& event )
{
char *contexto;
TPoint Pos;

	TScroller::handleEvent(event);
	switch (event.what) {
		case evCommand:
			switch (event.message.command) {
				case cmCopy:
					event.what=evCommand;
					event.message.command=cmInfCopy;
					event.message.infoPtr=this;
					putEvent(event);
				break;

				case cmFind:
					find();
				break;

				case cmSearchAgain:
					makeSearch();
				break;

				case cmInfDir:
					switchToTopic("(dir)");
				break;

				case cmInfTop:
					switchToTopic("Top");
				break;

				case cmInfNext:
					switchToTopic(topic->Next);
				break;

				case cmInfPrev:
					switchToTopic(topic->Prev);
				break;

				case cmInfUp:
					switchToTopic(topic->Up);
				break;

				case cmInfGoto:
					GotoWindow();
				break;

				case cmInfHistory:
					ControlWindow();
				break;

				case cmInfBack: {
					QuickLen=0;
					contexto=TakeFromHistory(Pos);
					switchToTopic(contexto,Pos);
				} break;

				case cmInfIndex:
					QuickLen=0;
					switchToTopic("Index");
				break;

				default: return;
			} break;
			clearEvent(event);
		break;

		case evKeyDown:
			switch (event.keyDown.keyCode) {
				case kbBack:
					if (QuickLen>0) {
						QuickLen--;
						drawView();
						break;
					}
				case kbAltF1: {
					QuickLen=0;
					contexto=TakeFromHistory(Pos);
					switchToTopic(contexto,Pos);
				} break;

				case kbTab:
					QuickLen=0;
					TabToNext(0);
				break;

				case kbShiftTab:
					QuickLen=0;
					TabToNext(1);
				break;

				case kbEnter:
				case 0xe00d:  // Keypad Enter
					QuickLen=0;
					if ((selected > 0) && (selected <= topic->getNumCrossRefs())) switchToTopic(topic->getCrossRef(selected-1));
				break;

				case kbF1:
					switchToTopic("(infview)");
				break;

				case kbEsc:
					if (owner->state & sfModal) endModal(cmCancel);
					else {
						event.what = evCommand;
						event.message.command = cmClose;
						putEvent(event);
					}
				break;

				default:
				int Key=toupper(event.keyDown.charScan.charCode);
					if ((Key>='A' && Key<='Z')||(Key>='0' && Key<='9')||(Key=='_')||(Key=='.')||(Key=='-')) {
						if (QuickLen<MAX_NODE_NAME) {
							QuickSearch[QuickLen++]=Key;
							if (topic->SearchNextWith(QuickSearch,QuickLen,selected,QuickVisPos))
								makeSelectVisible();
							else
								QuickLen--;
						}
					}
					else {
						switch (Key) {
							case kbCtrlB:
								contexto=TakeFromHistory(Pos);
								switchToTopic(contexto,Pos);
							break;

							case kbCtrlC:
								event.what=evCommand;
								event.message.command=cmInfCopy;
								event.message.infoPtr=this;
								putEvent(event);
							break;

							case kbCtrlH:
								ControlWindow();
							break;

							case kbCtrlL:
								makeSearch();
							break;

							case kbCtrlS:
								find();
							break;

							case kbCtrlN:
								switchToTopic(topic->Next);
							break;

							case kbCtrlP:
								switchToTopic(topic->Prev);
							break;

							case kbCtrlU:
								switchToTopic(topic->Up);
							break;

							case kbCtrlD:
								switchToTopic("(dir)");
							break;

							case kbCtrlT:
								switchToTopic("Top");
							break;

							case kbCtrlG:
								GotoWindow();
							break;

							case kbCtrlI:
								switchToTopic("Index");
							break;

							case kbCtrlE:
							case kbCtrlX:
							case kbCtrlR:
							break;

							default:
								if (QuickLen) {
									QuickLen=0;
									drawView();
								}
								return;
						}
						QuickLen=0;
						drawView();
					}
			}
			clearEvent(event);
		break;

		case evMouseDown:
			if (event.mouse.buttons==1) {
			int before;
				if (event.mouse.doubleClick) {
					if (selected>0) {
						QuickLen=0;
						switchToTopic(topic->getCrossRef(selected-1));
					}
				}
				else {
				int y,ly;
					Pos=makeLocal(event.mouse.where)+delta;
					selected=PointInCrossRef(Pos,topic,before)+1;
					TextSelected=False;
					ColStartSelect=0;
					ColEndSelect=size.x;
					ly=y=Pos.y+1;
					drawView();
					do {
						Pos=makeLocal(event.mouse.where)+delta;
						Pos.y++;
						if (y!=Pos.y) {
							TextSelected=True;
							if (y>Pos.y) {
								LineStartSelect=Pos.y+1;
								LineEndSelect=y;
							}
							else {
								LineStartSelect=y;
								LineEndSelect=Pos.y-1;
							}
						}
						else TextSelected=False;
						if (Pos.y!=ly) drawView();
						ly=Pos.y;
					} while( mouseEvent(event, evMouseMove + evMouseAuto) );
				}
			}
			else if (event.mouse.buttons==2) {
				QuickLen=0;
				contexto=TakeFromHistory(Pos);
				switchToTopic(contexto,Pos);
			}
			clearEvent(event);
		break;
	}
}


int StrNCmp(const char *s1, const char *s2, size_t n) {
	if (n == 0) return 0;
	do {
		if (toupper(*s1) != *s2++) return 1;
		if (*s1++ == 0) break;
	} while (--n != 0);
	return 0;
}


char *ScanStr(char *s, char *find, int &Linea, int &Col) {
char c, sc;
size_t len;
char Buf[256];

	strcpy(Buf,find);
	strupr(Buf);
	find=Buf;

	if ((c = *find++) != 0) {
		len = strlen(find);
		do {
			do {
				if ((sc = *s++) == 0) return 0;
				if (sc=='\n') {
					Col=0;
					Linea++;
				}
				else Col++;
			} while (toupper(sc) != c);
		} while (StrNCmp(s, find, len) != 0);
		s--;
	}
	Col--;
	return s;
}

char *ScanStrCase(char *s, char *find, int &Linea, int &Col) {
char c, sc;
size_t len;

	if ((c = *find++) != 0) {
		len = strlen(find);
		do {
			do {
				if ((sc = *s++) == 0) return 0;
				if (sc=='\n') {
					Col=0;
					Linea++;
				}
				else Col++;
			} while (sc != c);
		} while (strncmp(s, find, len) != 0);
		s--;
	}
	Col--;
	return s;
}


TDialog *createFindDialog();
TDialog *createInfFindDialog();

int TInfViewer::searchInCurrentTopic(int Linea,int Col,int largo) {
TPoint Punto;

	do {
		lastSearch=findType & fitCaseSens ?
			  ScanStrCase(lastSearch,findStr,Linea,Col) :
			  ScanStr(lastSearch,findStr,Linea,Col);
		if (lastSearch!=0) { // hit and
			if ( !(findType & fitWWord) ||	// (!Whole word or
			// is a whole word)
			(!isalpha(*(lastSearch-1)) && !isalpha(*(lastSearch+largo))) )
			{
				LineEndSelect=LineStartSelect=Linea+1;
				 ColStartSelect=Col;
				 ColEndSelect=Col+largo;
				 Punto.x=Col;
				 Punto.y=Linea+1;
				 makeVisible(Punto,largo);
				 TextSelected=True;
				 lastSearch+=largo;
				 return 1;
			}
			lastSearch+=largo;
			Col+=largo;
		}
	} while (lastSearch);
	TextSelected=False;
	return 0;
}


int TInfViewer::searchInCurrentFile(int Linea,int Col,int largo) {
char Buf[256];
char findUp[256];
FILE *f;

 // first in the current topic
	if (TopicInSearch!=fitNotInTopic && searchInCurrentTopic(Linea,Col,largo)) return 1;
 // now across topics
long PosTopic;
	strcpy(findUp,findStr);
	strupr(findUp);
char *s;
int LastTopic=TopicInSearch;
	while ((PosTopic=hFile->index->position(++TopicInSearch))!=-1) {
		hFile->fSeek(PosTopic);
		topic->ReadNodeInfo(*hFile);
		if (topic->Status) {
			switchToTopic("Top");
			break;
		}
		f=hFile->stream;
		do {
			if (fgets(Buf,256,f)==NULL) break;
			strupr(Buf);
			s=strstr(Buf,findUp);
		} while (s==NULL && Buf[0]!=31);

		if (Buf[0]!=31 && !feof(f)) {
			switchToTopic(hFile->index->Names[TopicInSearch]);
			lastSearch=topic->Text;
			if (searchInCurrentTopic(0,0,largo)) return 1;
		}
	};
	if (LastTopic!=fitNotInTopic) switchToTopic(hFile->index->Names[LastTopic]);
	return 0;
}

void TInfViewer::makeSearch() {
int Linea,Col;
int largo,Eureka=0;

	largo=strlen(findStr);
	if (largo==0) return;

 // Si finaliz una bsqueda antes y ahora presion Ctrl+L que vuelva al ppio.
	if (lastSearch==NULL) lastSearch=topic->Text;

	if (lastSearch!=topic->Text) {
		Linea=LastSearchLine;
		Col=LastSearchCol;
	}
	else {
		Linea=0;
		Col=0;
	}

	OpenVerbose=0;
	switch (findWhere) {
		case fitInTopic:
		   // Search in the current topic, is only in a large buffer
			Eureka=searchInCurrentTopic(Linea,Col,largo);
		break;

		case fitInFile:
		   // It's complex; and calls searchInCurrentTopic
			Eureka=searchInCurrentFile(Linea,Col,largo);
		break;

		case fitInDir:
		   // It's Waco, and infected (i kill thousands of bugs here).
			if (FileInSearch==fitNotInTopic) {
			  // It's the first time
			  // Keep track were start
				AddFileToNode(OriginalPlace.Name,topic->Node,hFile->NameOfFile);
				OriginalPlace.HisPos = cursor + delta;
				OriginalPlace.HisSel=selected;
			}
			else {
			  // Not the first time, continue in this file
				if (searchInCurrentFile(Linea,Col,largo)) {
					OpenVerbose=1;
					return;
				}
			}
		   // now across files
		   // Go to Top of Top
			switchToTopic("(dir)Top");
			while ((++FileInSearch)<topic->numRefs) {
				switchToTopic(topic->crossRefs[FileInSearch].Name);
				if (!hFile->Status) {
					TopicInSearch=fitNotInTopic;
					if (searchInCurrentFile(Linea,Col,largo)) {
						OpenVerbose=1;
						return;
					}
				}
				switchToTopic("(dir)Top");
			}
			switchToTopic(&OriginalPlace);
		break;
	}
	LastSearchLine=LineEndSelect-1;
	LastSearchCol=ColEndSelect;
	if (!Eureka) messageBox("Sorry can't find the string",mfError | mfOKButton);
	OpenVerbose=1;
}


void TInfViewer::find()
{
 TFindInfDialogRec findRec( findStr, findType, findWhere );
 lastSearch=topic->Text;
 FileInSearch=TopicInSearch=fitNotInTopic;
 if ( execDialog( createInfFindDialog(), &findRec ) != cmCancel )
   {
	strcpy( findStr, findRec.find );
	findType = findRec.options;
	findWhere =	 findRec.ops2;
	makeSearch();
   }
}


/***************************************************************

 class TInfWindow

 Just like THelpWindow.

***************************************************************/

TInfWindow::TInfWindow( TInfFile *hFile, char *context, char *match):
	   TWindow( TRect(0,0,50,18), "Info Viewer", wnNoNumber ),
	   TWindowInit( &TInfWindow::initFrame)
{
TRect r(0, 0, 50, 18);
	options |= ofCentered|ofFirstClick;
	if (!GT) r.grow(-1,-1); else {
		r.grow(-2,-1);
		r.a.x--;r.b.x--;
	}
	viewer=new TInfViewer (r,
		standardScrollBar(sbHorizontal | sbHandleKeyboard),
		standardScrollBar(sbVertical | sbHandleKeyboard), hFile, context, match);
	insert(viewer);
}

TInfWindow::~TInfWindow() {
	delete viewer;
}


TPalette& TInfWindow::getPalette() const {
static TPalette color(cInfWindowColor,sizeof(cInfWindowColor)-1);
static TPalette blackwhite(cInfWindowBW,sizeof(cInfWindowBW)-1);
static TPalette monochrome(cInfWindowMono,sizeof(cInfWindowMono)-1);
static TPalette *palettes[] = {&color,&blackwhite,&monochrome};

	return *(palettes[palette]);
}


/***************************************************************

 class TStrListBox

 Una ListBox que responde a Enter y Doble click.
 A List Box with Enter+Double click response.

 La respuesta es un mensaje cmStrChoose y en infoPtr el ndice
seleccionado.

***************************************************************/

void TStrListBox::handleEvent(TEvent& event)
{
 short a=focused;
 if ( (event.what==evKeyDown && event.keyDown.keyCode==kbEnter)
	|| (event.what == evMouseDown && event.mouse.doubleClick) )
   {
	message( owner, evBroadcast, cmStrChoose, (void *)&focused );
	clearEvent(event);
	return;
   }
 TListBox::handleEvent(event);
 if (focused!=a)
	draw();
}

/***************************************************************

 class THelpControlDialog

 Una caja de dilogo para controlar el help.
 A Dialog to control the help.

***************************************************************/

void THelpControlDialog::handleEvent(TEvent& event)
{
 TDialog::handleEvent(event);
 if( event.what == evCommand || event.what == evBroadcast)
  {
   switch( event.message.command )
		   {
			// a button
			case chcdHide:
				{
				endModal(event.message.command);
				clearEvent(event);
				}
				break;
			// from the list
			case cmStrChoose:
				{
				 endModal(chcdHistSel+*((ushort *)event.message.infoPtr));
				 clearEvent(event);
				}
				break;
			default:
				break;
		   }
  }
}


THelpControlDialog::THelpControlDialog(TCollectionNoSort *oCol) :
	TDialog( TRect( 1, 1, 51, 16 ), "History" ),
	TWindowInit( &THelpControlDialog::initFrame )
{
	options|=ofTopSelect|ofCentered;
	TRect r(37,12,48,14);
	insert( new TButton(r,"~C~lose",104,bfNormal) );

TScrollBar *sb;
	if (!GT) sb= new TScrollBar( TRect(47,2,48,11) );
	else sb = new TScrollBar( TRect(46,2,48,11) );
	insert(sb);

TStrListBox *ListaH;
	if (!GT) ListaH = new TStrListBox( TRect(2,2,47,11),(ushort)1, sb );
	else ListaH = new TStrListBox( TRect(2,2,46,11),(ushort)1, sb );
	insert(ListaH);
	ListaH->newList(oCol);
	selectNext( False );
}


TDialog *createInfFindDialog()
{
TDialog *d = new TDialog( TRect( 0, 0, 38, 15 ), "Find" );

	d->options |= ofCentered;

	TInputLine *control = new TInputLine( TRect( 3, 3, 32, 4 ), 80 );
	d->insert( control );
	d->insert( new TLabel( TRect( 2, 2, 15, 3 ), "~T~ext to find", control ) );
	d->insert( new THistory( TRect( 32, 3, 35, 4 ), control, 10 ) );

	d->insert( new TCheckBoxes( TRect( 3, 5, 35, 7 ),
		new TSItem( "~C~ase sensitive",
		new TSItem( "~W~hole words only", 0 ))));

	d->insert( new TRadioButtons( TRect( 3, 8, 35, 11 ),
		new TSItem( "In current ~t~opic",
		new TSItem( "In the ~f~ile",
		new TSItem( "In ~a~ll files", 0 )))));

	d->insert( new TButton( TRect( 14, 12, 24, 14 ), "O~K~", cmOK, bfDefault ) );
	d->insert( new TButton( TRect( 26, 12, 36, 14 ), "Cancel", cmCancel, bfNormal ) );

	d->selectNext( False );
	return d;
}

TDialog *createGoToDialog()
{
	TDialog *d = new TDialog( TRect( 0, 0, 38, 9 ), "Go To" );

	d->options |= ofCentered;

	TInputLine *control = new TInputLine( TRect( 3, 3, 32, 4 ), 80 );
	d->insert( control );
	d->insert( new TLabel( TRect( 2, 2, 15, 3 ), "~N~ame of Node", control ) );
	d->insert( new THistory( TRect( 32, 3, 35, 4 ), control, 10 ) );

	d->insert( new TButton( TRect( 14, 6, 24, 8 ), "O~K~", cmOK, bfDefault ) );
	d->insert( new TButton( TRect( 26, 6, 36, 8 ), "Cancel", cmCancel, bfNormal ) );

	d->selectNext( False );
	return d;
}

